<%
'SUBROUTINES DEFINED:
'"""""""""""""""""""
'SetupSessionVariables(AuthUser)		Sets up the session variables
'GetSessionStatusStr()					Returns the error string associated with the session error code
'SetError(Message)						Sets the text of the main error message
'SetReason(Message)						Sets the text of the reason paragraph
'AddFix(Message)						Adds an item to the bulleted list of suggestions
'Check_Browser_Capabilities()			Sets error if the Client browser lacks Tables and JavaScript support
'Invalid_Password()						Sets an error due to an invalid password
'IsConfID()								Sets error if the Conference ID is not set (inConfID)
'ValidateMeetingID()					Sets error if the DCS Meeting ID is not valid (inMeetingID)
'Verify_ConfLocator()					Verifies ConfLocator points to the Conference Locator
'DisplayErrorPage()						Setup the error page when we have an error
'
'FUNCTIONS DEFINED:
'"""""""""""""""""
'CheckSetError(Source, Description) Checks for error values in Result/Err and adds error messages if appropriate
'
' ================================ CONSTANTS =================================================
'ERROR CONSTANTS:
'C++ returns HRESULTS as 4-byte signed ints, so the bit pattern
'0x81000203 comes out as a negative number.
'VBScript also uses 4-byte signed ints, so assigning the bit patterns
'as below makes for better readability while still giving the 
'same negative numbers.
'If VBScript ever changes to use ints larger than 4 bytes, the
'bit patterns below will be interpreted as positive numbers and
'will have to be changed to explicitly reference the negative
'number returned by C++.
CONST E_CMS_EVENTMANAGER_NOT_INITIALIZED                = &H8004100A
CONST E_CMS_CONFERENCE_NOT_SCHEDULED                    = &H8004100B
CONST E_CMS_CONFERENCE_NOT_STARTED                      = &H8004100C
CONST E_CMS_CONFERENCE_NOT_RUNNING                      = &H8004100D
CONST E_CMS_CONFERENCE_NOT_FOUND                        = &H8004100E
CONST E_CMS_INVALID_CONFERENCE_PASSWORD                 = &H8004100F
CONST E_CMS_ANONYMOUS_USER_DENIED_ACCESS                = &H80041010
CONST E_CMS_USER_DENIED_ACCESS                          = &H80041011
CONST E_CMS_CTP_JOIN_REQUEST_FAILED                     = &H80041012
CONST E_CMS_PROVIDER_NOT_INITIALIZED                    = &H80041013
CONST E_CMS_PROVIDER_NOT_FOUND                          = &H80041014
CONST E_CMS_E_CONFERENCE_NOT_EXIST                      = &H80041015
CONST E_CMS_RECURRING_CONFERENCE_NOT_FOUND              = &H80041016
CONST E_CMS_NOT_HOST_SERVER                             = &H80041017
CONST E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND    = &H80041018
CONST E_CMS_AMBIGUOUS_RECURRING_JOIN                    = &H80041019
CONST E_CMS_TIME_EXTENSIONS_NOT_ALLOWED                 = &H8004101B
CONST E_CMS_RESOURCE_EXTENSIONS_NOT_ALLOWED             = &H8004101C
CONST E_CMS_SERVER_NOT_INITIALIZED                      = &H80041037
CONST E_CMS_PROFILE_STORE_NOT_INITIALIZED               = &H80041038
CONST E_CMS_SHUTTING_DOWN                               = &H4101E

CONST E_DCS_NO_MCUS_AVAILABLE                           = &H8004F001
CONST E_DCS_CONFERENCE_NOT_RUNNING                      = &H8004F002
CONST E_DCS_CONFERENCE_ALREADY_ENDED                    = &H8004F003
CONST E_DCS_ACCESS_DENIED_CAPACITY_LIMIT                = &H8004F004
CONST E_DCS_NO_PROXY_MCUS_AVAILABLE                     = &H8004F005
CONST E_DCS_NO_INTERNET_MCUS_AVAILABLE                  = &H8004F006
CONST E_DCS_NOT_RUNNING                                 = &H8004F007
CONST E_DCS_NOT_INIT                                    = &H8004F008

CONST E_NETMEETING_ERRORS_MASK                          = &H80040300
CONST E_NETMEETING_INVITE_FAILURE                       = &H8004036A
CONST E_NETMEETING_INVITE_TIMEOUT                       = &H80040372

CONST E_PKCS7_NO_CERT_STORE                             = &H80043000
CONST E_SESSION_UNAVAILABLE                             = &H80043001
CONST E_NO_DISPLAY_STATE                                = &H80043002
CONST E_UNSUPPORTED_TABLES_BROWSER                      = &H80043003
CONST E_UNSUPPORTED_JAVASCRIPT_BROWSER                  = &H80043004

CONST E_ACCESS_DENIED                                   = 70 '&H80070005 comes across as error 70 if returned
CONST E_ACCESS_DENIED_HRESULT                           = &H80070005 'if passed back as a result
CONST E_SERVER_CREATE_OBJECT                            = &H800401F3 'Server.CreateObject() error
CONST NM_E_NOT_ACTIVE                                   = &H81000203 'NetMeeting was closed since last use
CONST E_NO_GLOBAL_CONF_CALENDAR                         = &H80010105
CONST E_DSGETSITENAME_NO_SITE                           = &H8007077F
CONST E_MANUAL_JOIN_INSTRUCTIONS                        = &H80040100
CONST E_CMS_RESTARTED                                   = &H1CE

CONST E_MCU_HANG                                        = &H800706BA
CONST E_MCU_NO_SERVER_CERTIFICATE                       = &H80070546

'DISPLAY STATE CONTANTS:
'These define the various display states that can be used
'The quotes are required because the state is passed as a string
'The DCS programmatically uses {0,7,8} so those cannot easily be changed
CONST DISPLAY_JOIN                      = "0"
CONST DISPLAY_JOIN_PASSWORD             = "6"
CONST DISPLAY_PREJOIN                   = "7"
CONST DISPLAY_POSTJOIN                  = "8"
CONST DISPLAY_NO_MADCAP_SERVERS         = "9"
CONST DISPLAY_TOO_MANY_USERS            = "10"
CONST DISPLAY_ALL_MADCAP_SERVERS_FAILED = "11"
CONST DISPLAY_NO_MADCAP_SERVERS_MATCH_SCOPE = "12"
CONST DISPLAY_NO_MADCAP_SCOPES_FOUND    = "13"
CONST DISPLAY_NO_SCOPES_IN_RESOURCE     = "14"
CONST DISPLAY_MAX_JOIN_TYPES            = "14"
CONST DISPLAY_MULTICAST_CLIENT          = "15"
CONST DISPLAY_H323_CLIENT               = "16"
CONST DISPLAY_OLDER_H323_CLIENT         = "51"
CONST DISPLAY_NO_AUDIOVIDEO_CLIENT      = "52"
CONST DISPLAY_NO_AUDIOVIDEO_ACTIVEX     = "53"

CONST DISPLAY_WELCOME                   = "11"
CONST DISPLAY_RECURRING                 = "14"
CONST DISPLAY_AGENDA                    = "17"
CONST DISPLAY_MODIFY                    = "18"
CONST DISPLAY_MAX_NO_JOIN_TYPES         = "19"

CONST DISPLAY_MIN_ERR_TYPES             = "20"
CONST DISPLAY_ERR_CONFID                = "22"
CONST DISPLAY_ERR_CTP_STARTUP           = "23"
CONST DISPLAY_ERR_VALUE                 = "38"
CONST DISPLAY_MAX_ERR_TYPES             = "39"

'SESSION VARIABLE CONSTANTS
CONST SESSION_CONFPROFILE            = "ConfProfile"
CONST SESSION_CONFLOCATOR            = "ConfLocator"
CONST SESSION_CMSZONE                = "CMSZone"
CONST SESSION_CMSCONFIG              = "CMSConfig"
CONST SESSION_MEETINGID              = "MeetingID"
CONST SESSION_RESULT                 = "Result"
CONST SESSION_ERRNUMBER              = "ErrNumber"
CONST SESSION_ERRSOURCE              = "ErrSource"
CONST SESSION_ERRDESCRIPTION         = "ErrDescription"
CONST SESSION_STATUS                 = "Status"
CONST SESSION_ATTENDEE               = "Attendee"
CONST SESSION_PASSWORD				 = "Password"

CONST L_Page_HTMLTitle       = "Conferencia de Microsoft Exchange"
CONST L_ErrorPage_HTMLTitle  = "Error en Conferencia de Microsoft Exchange"
CONST L_TryTheFollowing_Text = "Pruebe lo siguiente:"

'Session debugging/status information strings (must stay the same as global.asa)
CONST L_OK_Text                 = "Aceptar"
CONST L_GetConfLocator_Text     = "No se pudo obtener el buscador de conferencias de la zona de administración de conferencia"
CONST L_GetZone_Text            = "No se pudo localizar la zona del objeto de configuración de administración de conferencia"
CONST L_CreateObject_Text       = "No se puede inicializar el objeto de configuración de administración de conferencias"
CONST L_Unknown_Text            = "Desconocido"
CONST L_Uninitialized_Text      = "Sin inicializar"

'Common strings
CONST L_MCUProxyInvite_ErrorMessage     = "Si está intentando unirse a la conferencia a través de un servidor proxy, es posible que el Servicio de conferencia mediante datos no pueda conectar con el programa cliente. Para conectar manualmente con el cliente de conferencia mediante datos, use la siguiente información:"
CONST L_ManualJoinServer_ErrorMessage   = "Servicio de conferencia mediante datos: "
CONST L_ManualJoinID_ErrorMessage       = "Id. de conferencia: "
CONST L_ManualJoinPassword_ErrorMessage = "Contraseña de conferencia: "
CONST L_NetMeetingInviteTitle_ErrorMessage  = "Error en los datos de la invitación a la conferencia"
CONST L_NetMeetingInviteReason_ErrorMessage = "El servicio Conferencia mediante datos no puede invitar a la conferencia al cliente de conferencia mediante datos T.120 (por ejemplo, Microsoft NetMeeting)."
CONST L_NetMeetingInviteFix1_ErrorMessage   = "Compruebe que inició su programa cliente de conferencias e intente unirse de nuevo a la conferencia."
CONST L_LinkToConferenceListsFix_ErrorMessage  = "Seleccione una conferencia actual en la "
CONST L_LinkToConferenceListsFix2_ErrorMessage = "lista de reuniones disponibles."

CONST PR_SUBJECT             = "subject"   'Defines the subject property code for user properties
CONST PR_BODY                = "268435487" 'Defines the body text property code for user properties
CONST PR_BODY_HTML           = "269680670" 'Defines the body text (in HTML) property code for user properties
CONST MAPI_RESOURCE          = "MAPI"      'Defines the resource used when getting user properties

CONST CONF_ID_CODED_LENGTH   = 255 'Length of the Base-64 encoded conference ID
CONST CONF_ID_DECODED_LENGTH = 22 'Conference ID must be 22 digits

' ================================ VARIABLES =================================================
'ERROR VARIABLES:
DIM ErrorMsg        'Holds the main error message (displayed at the top of the error page)
DIM Reason          'Holds the paragraph description of the error (displayed below the main message)
DIM Fixes()         'Holds the suggested remedies (displayed in the bulleted list below the paragraph)
DIM HiddenError     'Holds the system-level error message (displayed in small print at the bottom)
DIM ErrorCount      'Counts the errors encountered (0 or 1)
DIM Result          'Global variable used for function return values
DIM SessionErr(5)   'Holds the error messages that are defined in the session variables code to allow localization

' =============================== INITIALIZATION ==============================================
ErrorMsg        = ""
HiddenError     = ""
Reason          = ""
ErrorCount      = 0
Result          = 0
SessionErr(0)   = L_OK_Text
SessionErr(1)   = L_GetConfLocator_Text
SessionErr(2)   = L_GetZone_Text
SessionErr(3)   = L_CreateObject_Text
SessionErr(4)   = L_Unknown_Text
SessionErr(5)   = L_Uninitialized_Text
REDIM Fixes(0)                          'Puts the array Fixes in a known state

' ================================ FUNCTIONS =================================================
'== SUB: Sets up the session variables (GetSessionStatusStr() is used for SESSION_STATUS strings)
SUB SetupSessionVariables(AuthUser)
    ON ERROR RESUME NEXT

    DIM CMSConfiguration
    DIM CMSZone
    DIM ConfLocator
    
    Session(SESSION_RESULT)          = 0
    Session(SESSION_ERRNUMBER)       = 0
    Session(SESSION_ERRSOURCE)       = 0
    Session(SESSION_ERRDESCRIPTION)  = 0
    Session(SESSION_STATUS)          = 5 'L_Uninitialized_Text
    
    'Create the CMS Configuration object (dllhost will create this from xcmsadm)
    SET CMSConfiguration = Server.CreateObject("XCMSCOM.CMSConfiguration")
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 3 'L_CreateObject_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSCONFIG) = CMSConfiguration 'Save the singleton CMSConfig for up to 20 mins
    
    'Create the CMS Zone object (dllhost will create this from xcmsadm)
    CALL CMSConfiguration.GetZone("", CMSZone)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 2 'L_GetZone_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSZONE) = CMSZone 'Save the CMS Zone object for use later
    
    'Create the Conference Locator object (dllhost will create this from the xconfmgr service)
    CALL CMSZone.GetConferenceLocator(ConfLocator)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 1 'L_GetConfLocator_Text
        EXIT SUB
    END IF

	Session(SESSION_ATTENDEE)		 = AuthUser
	    
    SET Session(SESSION_CONFLOCATOR) = ConfLocator 'Save the Conference Locator for use later
    Session(SESSION_STATUS)          = 0 'L_OK_Text
END SUB

'== SUB: Creates the session status string that we use on the bottom of the error pages
FUNCTION GetSessionStatusStr(errVal)
    IF (errVal >= 0 AND errVal <= 5) THEN
        GetSessionStatusStr = SessionErr(errVal)
    ELSE
        GetSessionStatusStr = errVal
    END IF
END FUNCTION

'== SUB: Sets the text of the main error message
SUB SetError(Message, Value, Source, Description)
    IF (0 = ErrorCount) THEN
        ErrorCount  = ErrorCount + 1
        ErrorMsg    = ErrorMsg & Message
        HiddenError = HiddenError & Source & " Error #" & Hex(Value) & ": " & Description & vbNewLine
    END IF
END SUB

'== SUB: Sets the text of the reason paragraph
SUB SetReason(Message)
    Reason = Message
END SUB

'== SUB: Adds an item to the bulleted list of suggestions
SUB AddFix(Message)
    DIM NewSize
    
    NewSize = UBound(Fixes) + 1
    REDIM PRESERVE Fixes(NewSize)
    
    Fixes(NewSize) = Message
END SUB

'== FUNCTION: Checks for error values in Result/Err and adds error messages if appropriate
FUNCTION CheckSetError(ResultSource, ResultDescription)
    DIM Value, Source, Description
    
    IF (0 <> Err.Number) THEN
        Value       = Err.Number
        Source      = Err.Source & " / [" & ResultSource & "]"
        Description = Err.Description & " / [" & ResultDescription & "]"
        Err.Clear()
    ELSEIF (0 <> Result) THEN
        IF (IsNumeric(Result)) THEN
            Value = CDbl(Result)
        ELSE
            Value = Result
        END IF
        Source      = ResultSource
        Description = ResultDescription
        Result      = 0
    ELSE
        CheckSetError = FALSE
        EXIT FUNCTION
    END IF

    'Bitwise-AND to detect all NetMeeting errors
    IF (E_NETMEETING_ERRORS_MASK = (E_NETMEETING_ERRORS_MASK AND Value)) THEN

        IF (E_NETMEETING_INVITE_FAILURE = Value) THEN
            
            CALL SetError(L_NetMeetingInviteTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSEIF (E_NETMEETING_INVITE_TIMEOUT = Value) THEN
            CONST L_NetMeetingInviteTimeoutTitle_ErrorMessage  = "Superado el tiempo de espera para los datos de la invitación a la conferencia"
            CONST L_NetMeetingInviteTimeoutReason_ErrorMessage = "La invitación enviada por el servidor de conferencias caducó cuando el servidor intentaba invitar a la conferencia al programa cliente de conferencias (por ejemplo, Microsoft NetMeeting)."
            CONST L_NetMeetingInviteTimeoutFix1_ErrorMessage   = "Vuelva a unirse a la conferencia y acepte la invitación del servidor. Quizá deba traer la invitación al primer plano, ya que puede estar escondida en el escritorio, detrás de la ventana activa."
            
            CALL SetError(L_NetMeetingInviteTimeoutTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteTimeoutReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteTimeoutFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSE
            CONST L_NetMeetingMaskTitle_ErrorMessage  = "Conflicto de NetMeeting"
            CONST L_NetMeetingMaskReason_ErrorMessage = "NetMeeting controla los recursos en el equipo, o no funciona correctamente."
            CONST L_NetMeetingMaskFix1_ErrorMessage   = "Cierre otros programas de vídeo, audio o red que puedan entrar en conflicto con NetMeeting."
            
            CALL SetError(L_NetMeetingMaskTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingMaskReason_ErrorMessage)
            CALL AddFix(L_NetMeetingMaskFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        END IF

        EXIT FUNCTION
    END IF

    SELECT CASE Value
        CASE E_CMS_EVENTMANAGER_NOT_INITIALIZED,E_CMS_SERVER_NOT_INITIALIZED
            CONST L_EventManagerNotInitializedTitle_ErrorMessage  = "Servidor no inicializado"
            CONST L_EventManagerNotInitializedReason_ErrorMessage = "El servicio Conferencia de Exchange se está iniciando y todavía no ha completado este proceso."
            CONST L_EventManagerNotInitializedFix1_ErrorMessage   = "Espere unos minutos e inténtelo de nuevo."
            
            CALL SetError(L_EventManagerNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_EventManagerNotInitializedReason_ErrorMessage)
            CALL AddFix(L_EventManagerNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROFILE_STORE_NOT_INITIALIZED
            CONST L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage    = "Almacén de servidor no inicializado"
            CONST L_ServerOrProfileStoreNotInitializedReason_ErrorMessage   = "No se inicializó el servidor de conferencia de Exchange."
            CONST L_ProfileStoreNotInitializedFix1_ErrorMessage             = "Póngase en contacto con el administrador del sistema. Es posible que no esté disponible el almacén del buzón de calendario de la conferencia."
                        
            CALL SetError(L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerOrProfileStoreNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProfileStoreNotInitializedFix1_ErrorMessage)

        CASE E_CMS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningCMSTitle_ErrorMessage  = "La conferencia no se está ejecutando"
            CONST L_ConferenceNotRunningCMSReason_ErrorMessage = "La conferencia en la que intentó el acceso no está preparada o el proveedor de tecnología de conferencias no permitió que se iniciara la conferencia."
            CONST L_ConferenceNotRunningCMSFix1_ErrorMessage   = "Espere unos minutos y vuelva a intentarlo."
            
            CALL SetError(L_ConferenceNotRunningCMSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningCMSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningCMSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_SCHEDULED
            CONST L_ConferenceNotScheduledTitle_ErrorMessage  = "Conferencia no programada"
            CONST L_ConferenceNotScheduledReason_ErrorMessage = "El servicio Conferencia de Exchange no programó esta conferencia (determinada por el Id. de la reunión en la dirección URL)."
            CONST L_ConferenceNotScheduledFix1_ErrorMessage   = "Quizás se eliminó la conferencia o el Id. de conferencia está dañado."
            CONST L_ConferenceNotScheduledFix2_ErrorMessage   = "Póngase en contacto con el organizador de la reunión o el administrador del sistema."
            
            CALL SetError(L_ConferenceNotScheduledTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotScheduledReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix2_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_CONFERENCE_NOT_STARTED
            CONST L_ConferenceNotStartedTitle_ErrorMessage  = "Conferencia no iniciada"
            CONST L_ConferenceNotStartedReason_ErrorMessage = "Se está iniciando la conferencia, pero aún no se completó el proceso de inicio."
            CONST L_ConferenceNotStartedFix1_ErrorMessage   = "Espere unos minutos e inténtelo de nuevo."
            
            CALL SetError(L_ConferenceNotStartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotStartedReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotStartedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_FOUND,E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND,E_CMS_AMBIGUOUS_RECURRING_JOIN,E_CMS_E_CONFERENCE_NOT_EXIST,1 'S_FALSE
            CONST L_ConferenceNotFoundTitle_ErrorMessage  = "Conferencia no encontrada"
            CONST L_ConferenceNotFoundReason_ErrorMessage = "El servicio de administración de conferencia no puede encontrar la conferencia a la que intentado entrar."
            CONST L_ConferenceNotFoundFix1_ErrorMessage   = "Si la conferencia se programó recientemente, espere unos minutos y vuelva a intentarlo."
            CONST L_ConferenceNotFoundFix2_ErrorMessage   = "Póngase en contacto con el organizador de la conferencia; puede haberse cancelado."
            CONST L_ConferenceNotFoundFix3_ErrorMessage   = "Compruebe que el Id. de la reunión que aparece en la dirección URL del explorador es la misma que la de su conferencia."
            CONST L_ConferenceNotFoundFix4_ErrorMessage   = "Si es una conferencia periódica, puede haber problemas al resolver las instancias individuales."
            
            CALL SetError(L_ConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix2_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix3_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix4_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_SHUTTING_DOWN
            CONST L_ConfServerShuttingDownTitle_ErrorMessage  = "Cerrando el servicio de administración de conferencia"
            CONST L_ConfServerShuttingDownReason_ErrorMessage = "El servicio de administración de conferencia se está cerrando."
            CONST L_ConfServerShuttingDownFix1_ErrorMessage   = "Espere unos minutos a que el servicio se reinicie para poder reanudar la conferencia."
            CONST L_ConfServerShuttingDownFix2_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_ConfServerShuttingDownTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConfServerShuttingDownReason_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix1_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix2_ErrorMessage)

        CASE E_CMS_INVALID_CONFERENCE_PASSWORD
            CONST L_InvalidConferencePasswordTitle_ErrorMessage  = "Contraseña de conferencia no válida"
            CONST L_InvalidConferencePasswordReason_ErrorMessage = "El servicio Administración de conferencia denegó su solicitud para unirse a la conferencia porque la contraseña no es válida."
            CONST L_InvalidConferencePasswordFix1_ErrorMessage   = "Compruebe que escribió la contraseña de conferencia correcta."

            CALL SetError(L_InvalidConferencePasswordTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_InvalidConferencePasswordReason_ErrorMessage)
            CALL AddFix(L_InvalidConferencePasswordFix1_ErrorMessage)
        
        CASE E_CMS_ANONYMOUS_USER_DENIED_ACCESS
            CONST L_AnonymousUserDeniedAccessTitle_ErrorMessage  = "Acceso anónimo denegado"
            CONST L_AnonymousUserDeniedAccessReason_ErrorMessage = "El servicio Administración de conferencia denegó su solicitud para unirse a la conferencia porque no le pudo identificar."
            CONST L_AnonymousUserDeniedAccessFix1_ErrorMessage   = "Asegúrese de que intenta obtener acceso a una conferencia privada a la que fue invitado."
            CONST L_AnonymousUserDeniedAccessFix2_ErrorMessage   = "Asegúrese de que inició la sesión en la red con sus datos, de forma que se le pueda identificar."

            CALL SetError(L_AnonymousUserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_AnonymousUserDeniedAccessReason_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix2_ErrorMessage)
        
        CASE E_CMS_USER_DENIED_ACCESS
            CONST L_UserDeniedAccessTitle_ErrorMessage  = "Acceso denegado"
            CONST L_UserDeniedAccessReason_ErrorMessage = "El servicio Administración de conferencia denegó la solicitud para unirse a la conferencia porque no tiene los permisos necesarios. Se le autenticó como: "
            CONST L_UserDeniedAccessFix1_ErrorMessage   = "Compruebe que no está intentando unirse a una conferencia privada a la que no haya sido invitado. Consulte la invitación original de la conferencia y compruebe que está activada la casilla de verificación Permitir participantes externos. Consulte la invitación original de la conferencia y compruebe que su nombre de usuario se encuentra en la lista Para o CC de la invitación y que está autenticado para el servidor como ese usuario."
            CONST L_UserDeniedAccessFix2_ErrorMessage   = "Póngase en contacto con el administrador del sistema. Probablemente los permisos de la de raíz virtual de la conferencia no estén correctamente configurados o que el servicio Administración de conferencia fuerce una autenticación del cliente para conferencias privadas (es decir, el valor Autenticar el acceso a las páginas de reuniones privadas está activado)."

            CALL SetError(L_UserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_UserDeniedAccessReason_ErrorMessage & Request.ServerVariables("AUTH_USER"))
            CALL AddFix(L_UserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_UserDeniedAccessFix2_ErrorMessage)

        CASE E_CMS_CTP_JOIN_REQUEST_FAILED
            CONST L_CTPJoinRequestFailedTitle_ErrorMessage  = "Error en una solicitud de unión CTP"
            CONST L_CTPJoinRequestFailedReason_ErrorMessage = "El servicio de administración de conferencia rechazó la solicitud porque el proveedor de tecnología de conferencia no permitió la incorporación a la conferencia."
            CONST L_CTPJoinRequestFailedFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_CTPJoinRequestFailedTitle_ErrorMessage, Value, Replace(Request.QueryString("PNAME"), "+"," "), Description)
            CALL SetReason(L_CTPJoinRequestFailedReason_ErrorMessage)
            CALL AddFix(L_CTPJoinRequestFailedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_INITIALIZED
            CONST L_ProviderNotInitializedTitle_ErrorMessage  = "Proveedor no inicializado"
            CONST L_ProviderNotInitializedReason_ErrorMessage = "El servicio de administración de conferencia rechazó la solicitud porque el proveedor de tecnología de conferencia no terminó de inicializarse."
            CONST L_ProviderNotInitializedFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_ProviderNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProviderNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_FOUND
            CONST L_ProviderNotFoundTitle_ErrorMessage  = "Proveedor no encontrado"
            CONST L_ProviderNotFoundReason_ErrorMessage = "El servicio Administración de conferencia denegó su solicitud porque no puede conectar con un proveedor de tecnología de conferencia."
            CONST L_ProviderNotFoundFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_ProviderNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotFoundReason_ErrorMessage)
            CALL AddFix(L_ProviderNotFoundFix1_ErrorMessage)
        
        CASE E_CMS_RECURRING_CONFERENCE_NOT_FOUND
            CONST L_RecurringConferenceNotFoundTitle_ErrorMessage  = "Conferencia periódica no encontrada"
            CONST L_RecurringConferenceNotFoundReason_ErrorMessage = "El servicio de administración de conferencia rechazó la solicitud porque no encuentra la conferencia periódica a la que intenta unirse."
            CONST L_RecurringConferenceNotFoundFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_RecurringConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_RecurringConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_RecurringConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_NOT_HOST_SERVER
            CONST L_NotHostServerTitle_ErrorMessage  = "Dirección URL de host no válida"
            CONST L_NotHostServerReason_ErrorMessage = "El servicio de administración de conferencia denegó su solicitud porque este servidor no es el servidor host."
            CONST L_NotHostServerFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_NotHostServerTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NotHostServerReason_ErrorMessage)
            CALL AddFix(L_NotHostServerFix1_ErrorMessage)

        CASE E_DCS_NO_MCUS_AVAILABLE
            CONST L_NoAvailableMCUsTitle_ErrorMessage  = "Ningún servidor MCU T.120 disponible"
            CONST L_NoAvailableMCUsReason_ErrorMessage = "El servicio Conferencia mediante datos no está disponible o no está configurado para permitir una conexión de servidor MCU T.120 desde su dirección. Para unirse a una conferencia, el cliente de conferencia mediante datos (por ejemplo, NetMeeting) debe conectarse a un servidor MCU T.120."
            CONST L_NoAvailableMCUsFix1_ErrorMessage   = "Si el problema persiste, póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_NoAvailableMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_PROXY_MCUS_AVAILABLE
            CONST L_NoAvailableProxyMCUsTitle_ErrorMessage  = "Ningún servidor proxy MCU T.120 disponible"
            CONST L_NoAvailableProxyMCUsReason_ErrorMessage = "El servicio Conferencia mediante datos no está disponible o no está configurado para permitir una conexión de servidor proxy MCU T.120 desde su sitio Windows 2000. Para unirse a una conferencia en otro sitio es necesario establecer una conexión con un servidor proxy MCU T.120."
            CONST L_NoAvailableProxyMCUsFix1_ErrorMessage   = "Si el problema persiste, póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_NoAvailableProxyMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableProxyMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableProxyMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_INTERNET_MCUS_AVAILABLE
            CONST L_NoAvailableInternetMCUsTitle_ErrorMessage  = "Ningún servidor de Internet MCU T.120 disponible"
            CONST L_NoAvailableInternetMCUsReason_ErrorMessage = "El servicio Conferencia mediante datos no está disponible o no está configurado para permitir una conexión de servidor de Internet MCU T.120. Para unirse a una conferencia en otra organización es necesario establecer una conexión con un servidor de Internet MCU T.120."
            CONST L_NoAvailableInternetMCUsFix1_ErrorMessage   = "Si el problema persiste, póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_NoAvailableInternetMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableInternetMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableInternetMCUsFix1_ErrorMessage)

        CASE E_DCS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningDCSTitle_ErrorMessage  = "La conferencia no se está ejecutando"
            CONST L_ConferenceNotRunningDCSReason_ErrorMessage = "La conferencia no se está ejecutando actualmente en el servidor MCU T.120."
            CONST L_ConferenceNotRunningDCSFix1_ErrorMessage   = "Si el problema persiste, póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_ConferenceNotRunningDCSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningDCSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningDCSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_CONFERENCE_ALREADY_ENDED
            CONST L_ConferenceAlreadyEndedTitle_ErrorMessage  = "Conferencia finalizada"
            CONST L_ConferenceAlreadyEndedReason_ErrorMessage = "La conferencia mediante datos a la que intentó unirse ya no está activa."
            CONST L_ConferenceAlreadyEndedFix1_ErrorMessage   = "Si el problema persiste, póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_ConferenceAlreadyEndedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceAlreadyEndedReason_ErrorMessage)
            CALL AddFix(L_ConferenceAlreadyEndedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_ACCESS_DENIED_CAPACITY_LIMIT
            CONST L_CapacityLimitTitle_ErrorMessage  = "Límite de capacidad de la conferencia mediante datos"
            CONST L_CapacityLimitReason_ErrorMessage = "Esta conferencia mediante datos alcanzó la capacidad máxima y no puede aceptar nuevos usuarios por el momento."
            CONST L_CapacityLimitFix1_ErrorMessage   = "Espere unos minutos y luego intente unirse de nuevo a la conferencia. Puede que otros usuarios hayan abandonado la conferencia desde que intentó unirse por última vez."
            CONST L_CapacityLimitFix2_ErrorMessage   = "Póngase en contacto con el organizador de la reunión."
            
            CALL SetError(L_CapacityLimitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CapacityLimitReason_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix1_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix2_ErrorMessage)

        CASE E_DCS_NOT_RUNNING
            CONST L_DCSNotRunningTitle_ErrorMessage  = "El servicio Conferencia mediante datos no se está ejecutando"
            CONST L_DCSNotRunningReason_ErrorMessage = "El servicio Conferencia mediante datos no está en ejecución en este momento."
            CONST L_DCSNotRunningFix1_ErrorMessage   = "Espere unos minutos y a continuación intente unirse a la conferencia de nuevo. Probablemente el servicio se esté reiniciando."
            CONST L_DCSNotRunningFix2_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_DCSNotRunningTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotRunningReason_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix1_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix2_ErrorMessage)

        CASE E_DCS_NOT_INIT
            CONST L_DCSNotInitTitle_ErrorMessage  = "El servicio Conferencia mediante datos no está inicializado"
            CONST L_DCSNotInitReason_ErrorMessage = "No finalizó la inicialización del servicio de conferencia mediante datos."
            CONST L_DCSNotInitFix1_ErrorMessage   = "Espere unos minutos e intente unirse a la conferencia de nuevo."
            CONST L_DCSNotInitFix2_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_DCSNotInitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotInitReason_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix1_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix2_ErrorMessage)

        CASE E_PKCS7_NO_CERT_STORE
            CONST L_NoCertStoreTitle_ErrorMessage    = "Error al abrir el almacén de certificados"
            CONST L_NoCertStoreReason_ErrorMessage   = "Error al abrir el Almacén de certificados en el servidor de administración de conferencia al que intentaba unirse."
            CONST L_NoCertStoreFix1_ErrorMessage     = "Póngase en contacto con el administrador del sistema."

            CALL SetError(L_NoCertStoreTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoCertStoreReason_ErrorMessage)
            CALL AddFix(L_NoCertStoreFix1_ErrorMessage)
        
        CASE E_MCU_NO_SERVER_CERTIFICATE
            CONST L_NoServerCertificateTitle_ErrorMessage    = "No hay ningún certificado de servidor de conferencia mediante datos"
            CONST L_NoServerCertificateReason_ErrorMessage   = "El servidor de conferencia mediante datos de Exchange no puede proporcionar conferencias privadas en este momento."
            CONST L_NoServerCertificateFix1_ErrorMessage     = "Póngase en contacto con el administrador del sistema para asegurarse de que está instalado un certificado de máquina en el servidor de conferencia mediante datos."

            CALL SetError(L_NoServerCertificateTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoServerCertificateReason_ErrorMessage)
            CALL AddFix(L_NoServerCertificateFix1_ErrorMessage)

        CASE E_MANUAL_JOIN_INSTRUCTIONS            
            CONST L_ManualJoinInstructionsTitle_ErrorMessage  = "Instrucciones para unirse"
            CALL SetError(L_ManualJoinInstructionsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))


        CASE E_SESSION_UNAVAILABLE
        
            SELECT CASE Session(SESSION_RESULT)

                CASE &H8007000E
                    CONST L_SessionUnavailableResoveHostTitle_ErrorMessage    = "No se puede resolver el host"
                    CONST L_SessionUnavailableResoveHostReason_ErrorMessage   = "Error en el servidor Web de conferencias de Exchange. El servidor no pudo resolver el nombre de host para el servidor de directorios."
                    CONST L_SessionUnavailableResoveHostFix1_ErrorMessage     = "Póngase en contacto con el administrador del sistema."

                    CALL SetError(L_SessionUnavailableResoveHostTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableResoveHostReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableResoveHostFix1_ErrorMessage)

                CASE &H8000FFFF
                    CONST L_SessionUnavailableNoRightsTitle_ErrorMessage    = "Derechos insuficientes"
                    CONST L_SessionUnavailableNoRightsReason_ErrorMessage   = "Error en el servidor Web de conferencias de Exchange. No dispone de los derechos necesarios para tener acceso al servidor de directorios. Es posible que no estén configuradas correctamente la cuenta de IIS predeterminada o la seguridad del servidor de directorios."
                    CONST L_SessionUnavailableNoRightsFix1_ErrorMessage     = "Póngase en contacto con el administrador del sistema."

                    CALL SetError(L_SessionUnavailableNoRightsTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableNoRightsReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableNoRightsFix1_ErrorMessage)

                CASE &H800704E1
                    CONST L_SessionUnavailableBadSiteTitle_ErrorMessage    = "Sitio no válido"
                    CONST L_SessionUnavailableBadSiteReason_ErrorMessage   = "Error en el servidor Web de conferencias de Exchange. El servicio estaba intentando buscar en una zona un sitio que no pudo encontrar."
                    CONST L_SessionUnavailableBadSiteFix1_ErrorMessage     = "Póngase en contacto con el administrador del sistema."

                    CALL SetError(L_SessionUnavailableBadSiteTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableBadSiteReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableBadSiteFix1_ErrorMessage)
            
                CASE ELSE
                    CONST L_SessionUnavailableTitle_ErrorMessage    = "Servidor no disponible"
                    CONST L_SessionUnavailableReason_ErrorMessage   = "El servidor Web de conferencias de Exchange no está disponible."
                    CONST L_SessionUnavailableFix1_ErrorMessage     = "Cierre el explorador y vuelva a intentar la operación."
                    CONST L_SessionUnavailableFix2_ErrorMessage     = "Póngase en contacto con el administrador del sistema."

                    CALL SetError(L_SessionUnavailableTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix1_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix2_ErrorMessage)
        
            END SELECT
        
        CASE E_SERVER_CREATE_OBJECT
            CONST L_ServerCreateObjectTitle_ErrorMessage  = "Error de configuración del servidor Web"
            CONST L_ServerCreateObjectReason_ErrorMessage = "El servidor Web con el que intenta conectarse no está configurado para trabajar con los componentes del servicio Conferencia de Exchange."
            CONST L_ServerCreateObjectFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_ServerCreateObjectTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerCreateObjectReason_ErrorMessage)
            CALL AddFix(L_ServerCreateObjectFix1_ErrorMessage)

        CASE E_UNSUPPORTED_JAVASCRIPT_BROWSER
            CONST L_JavaScriptRequiredTitle_ErrorMessage  = "Se requiere compatibilidad con Javascript"
            CONST L_JavaScriptRequiredReason_ErrorMessage = "Para ver esta página debe utilizar un explorador compatible con Javascript, como Internet Explorer 5.0."
            CONST L_JavaScriptRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Obtenga Internet Explorer</A>."
        
            CALL SetError(L_JavaScriptRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support javascript")
            CALL SetReason(L_JavaScriptRequiredReason_ErrorMessage)
            CALL AddFix(L_JavaScriptRequiredFix1_ErrorMessage)

        CASE E_UNSUPPORTED_TABLES_BROWSER
            CONST L_TablesRequiredTitle_ErrorMessage  = "Se requiere compatibilidad con tablas"
            CONST L_TablesRequiredReason_ErrorMessage = "Para ver esta página, debe utilizar un explorador compatible con tablas, como Internet Explorer 5.0."
            CONST L_TablesRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Obtenga Internet Explorer</A>."
        
            CALL SetError(L_TablesRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support tables")
            CALL SetReason(L_TablesRequiredReason_ErrorMessage)
            CALL AddFix(L_TablesRequiredFix1_ErrorMessage)

        CASE E_ACCESS_DENIED
            CONST L_AccessDeniedTitle_ErrorMessage  = "Acceso denegado"
            CONST L_AccessDeniedReason_ErrorMessage = "El Servicio de administración de conferencias denegó su solicitud porque no tiene permisos."
            CONST L_AccessDeniedFix1_ErrorMessage   = "Si la conferencia requiere una contraseña, compruebe que utiliza la contraseña correcta."
            CONST L_AccessDeniedFix2_ErrorMessage   = "Asegúrese de que no intenta unirse a una conferencia privada a la que no fue invitado."
            CONST L_AccessDeniedFix3_ErrorMessage   = "Póngase en contacto con el administrador del sistema."

            Err.Number = E_ACCESS_DENIED_HRESULT 'Set for better display
            CALL SetError(L_AccessDeniedTitle_ErrorMessage, Value, Source, Description)
            Err.Number = E_ACCESS_DENIED 'Reset for no complications
            CALL SetReason(L_AccessDeniedReason_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix1_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix2_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix3_ErrorMessage)

        CASE E_CMS_RESTARTED
            CONST L_CMSRestartedTitle_ErrorMessage  = "Error al conectar con el servicio Conferencia de Exchange"
            CONST L_CMSRestartedReason_ErrorMessage = "El servicio Conferencia de Exchange no está disponible en esto momento."
            CONST L_CMSRestartedFix1_ErrorMessage   = "Cierre el explorador y abra una nueva conexión con el servicio Conferencia de Exchange."
            CONST L_CMSRestartedFix2_ErrorMessage   = "Si aún no puede conectar, póngase en contacto con el administrador. Es posible que el servicio no esté en ejecución."
            
            CALL SetError(L_CMSRestartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CMSRestartedReason_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix1_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix2_ErrorMessage)
        
        CASE E_MCU_HANG
            CONST L_MCUHangTitle_ErrorMessage  = "Error al conectar con el servidor de Conferencia mediante datos"
            CONST L_MCUHangReason_ErrorMessage = "Error al funcionar el servicio Conferencia de Exchange con el servidor de conferencia mediante datos."
            CONST L_MCUHangFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_MCUHangTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_MCUHangReason_ErrorMessage)
            CALL AddFix(L_MCUHangFix1_ErrorMessage)

        CASE E_NO_GLOBAL_CONF_CALENDAR
            CONST L_NoGlobalConfCalTitle_ErrorMessage  = "Servicio Conferencia de Exchange configurado incorrectamente"
            CONST L_NoGlobalConfCalReason_ErrorMessage = "El servicio Conferencia de Exchange puede que no tenga definido un buzón de conferencia predeterminado."
            CONST L_NoGlobalConfCalFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_NoGlobalConfCalTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoGlobalConfCalReason_ErrorMessage)
            CALL AddFix(L_NoGlobalConfCalFix1_ErrorMessage)

        CASE E_DSGETSITENAME_NO_SITE
            CONST L_DsGetSiteNameTitle_ErrorMessage  = "Sitio sin ubicar"
            CONST L_DsGetSiteNameReason_ErrorMessage = "El servicio Conferencia de Exchange no puede ubicar su servidor Active Directory."
            CONST L_DsGetSiteNameFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_DsGetSiteNameTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DsGetSiteNameReason_ErrorMessage)
            CALL AddFix(L_DsGetSiteNameFix1_ErrorMessage)

        CASE ELSE 'OTHER ERRORS
                    
            CONST L_DefaultTitle_ErrorMessage  = "Error de servidor"
            CONST L_DefaultReason_ErrorMessage = "El servicio Conferencia de Exchange detectó un error de servidor."
            CONST L_DefaultFix1_ErrorMessage   = "Póngase en contacto con el administrador del sistema."
            
            CALL SetError(L_DefaultTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DefaultReason_ErrorMessage)
            CALL AddFix(L_DefaultFix1_ErrorMessage)

    END SELECT

    CheckSetError = Value
END FUNCTION

'== SUB: Verifies ConfLocator points to the Conference Locator
SUB Verify_ConfLocator()
    ON ERROR RESUME NEXT

	DIM AuthUser
    
	AuthUser	=  Request.ServerVariables("AUTH_USER")
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR 0 <> Session(SESSION_ERRNUMBER) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE)) OR (AuthUser <> "" AND LCase(AuthUser) <> LCase(Session(SESSION_ATTENDEE)))) THEN
        CALL SetupSessionVariables(AuthUser)
    END IF
    
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) AND 0 <> Session(SESSION_ERRNUMBER)) THEN
        Err.Number      = Session(SESSION_ERRNUMBER)
        Err.Description = Session(SESSION_ERRDESCRIPTION)
        Err.Source      = Session(SESSION_ERRSOURCE)
    ELSEIF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE))) THEN
        Result          = E_SESSION_UNAVAILABLE
    END IF
END SUB

'== SUB: Sets error if the Client browser lacks Tables and JavaScript support
SUB Check_Browser_Capabilities()
    DIM Browscap
    
    SET Browscap = Server.CreateObject("MSWC.BrowserType")

    ' No longer trying to detect javascript from the browser (wasn't working with Navigator)
    'IF (0 = Browscap.JavaScript) THEN
    '    displayState = DISPLAY_ERR_VALUE
    '    Err.Number   = E_UNSUPPORTED_JAVASCRIPT_BROWSER
    'ELSE
    IF (0 = Browscap.tables) THEN
        displayState = DISPLAY_ERR_VALUE
        Err.Number   = E_UNSUPPORTED_TABLES_BROWSER
    END IF
END SUB

'== SUB: Sets an error due to an invalid password
SUB Invalid_Password()
    CONST L_IncorrectPasswordTitle_ErrorMessage  = "Contraseña incorrecta"
    CONST L_IncorrectPasswordReason_ErrorMessage = "No escribió la contraseña necesaria para unirse a esta conferencia. Si escribió la dirección URL anterior, compruebe que está bien escrita. Puede que no escribiera correctamente la contraseña."
    CONST L_IncorrectPasswordFix1_ErrorMessage   = "Compruebe lo que ha escrito."
    CONST L_IncorrectPasswordFix2_ErrorMessage   = "Póngase en contacto con el organizador de la conferencia o con el administrador del sistema."
        
    CALL SetError(L_IncorrectPasswordTitle_ErrorMessage, 0, "Security", "Invalid Password")
    CALL SetReason(L_IncorrectPasswordReason_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix1_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix2_ErrorMessage)
END SUB

'== SUB: Sets error if the Conference ID is not set
SUB IsConfID()
    IF ("" = inConfID OR CONF_ID_CODED_LENGTH < Len(inConfID)) THEN
        displayState = DISPLAY_ERR_CONFID
    END IF
END SUB

'== SUB: Sets error if the DCS Meeting ID is not valid
SUB ValidateMeetingID()
    IF (CONF_ID_DECODED_LENGTH <> Len(inMeetingID)) THEN
        CONST L_NoConferenceIDTitle_ErrorMessage  = "La dirección URL de acceso a la conferencia no es válida"
        CONST L_NoConferenceIDReason_ErrorMessage = "Sólo puede unirse a una conferencia desde una dirección URL de acceso a conferencias."
        CONST L_NoConferenceIDFix1_ErrorMessage   = "Si copió la dirección URL, compruebe el texto que escribió. O bien, únase a una conferencia a la que le invitaran por correo electrónico."

        Err.Number      = Len(inMeetingID)
        Err.Description = "Invalid conference ID"
        Err.Source      = "Exchange Conferencing Service"
        CALL SetError(L_NoConferenceIDTitle_ErrorMessage, 0, "Validate Meeting ID", "Invalid Conference ID")
        CALL SetReason(L_NoConferenceIDReason_ErrorMessage)
        CALL AddFix(L_NoConferenceIDFix1_ErrorMessage)
        CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
    END IF
END SUB

'== SUB: Setup the error page when we have an error
SUB DisplayErrorPage() %>
<TITLE><%=L_ErrorPage_HTMLTitle%></TITLE>
</HEAD>
<body BGCOLOR="#FFFFFF" BACKGROUND="filespw.gif" LEFTMARGIN="40" RIGHTMARGIN="40" TEXT="#000000" LINK="#000000" ALINK="#FFCC66" VLINK="#0080FF" STYLE="background-color:#FFFFFF; background-image:url(filespw.gif); background-attachment:fixed; background-repeat:no-repeat; background-position:bottom right;">

<center>
<table CELLSPACING="12">
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><b><font FACE="verdana" SIZE="+3"><%=ErrorMsg%></font></b></td></tr>
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><font FACE="verdana" SIZE="-1">
    <%=Reason%>
    <P><%=L_TryTheFollowing_Text%></P>
    <UL>
        <%
            DIM count
            FOR count = 1 TO UBound(Fixes)
                Response.write("<LI>" + Fixes(count) + "</LI>")
            NEXT
        %>
    </UL>
    <P>
    <SMALL>
        <%=HiddenError%>
        <BR>
        <%=L_Page_HTMLTitle%>
    </SMALL>
</font></td></tr>
</table>
</center>
</body>
</HTML>
<% END SUB %>
